org.modeshape.jcr.query.model

## Class ReferenceValue

- java.lang.Object
- - org.modeshape.jcr.query.model.ReferenceValue

- All Implemented Interfaces:
    Serializable, DynamicOperand, Operand, ReferenceValue, LanguageObject, Visitable

      @Immutable
      public class ReferenceValue
      extends Object
      implements DynamicOperand, ReferenceValue

  A dynamic operand that evaluates to the value(s) of a single or any reference property on a selector, used in a `Comparison` constraint.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReferenceValue(SelectorName selectorName)` Create a dynamic operand that evaluates to all of the reference values of the node identified by the selector.
    `ReferenceValue(SelectorName selectorName, String propertyName)` Create a dynamic operand that evaluates to the values of a single reference property of the node identified by the selector.
    `ReferenceValue(SelectorName selectorName, String propertyName, boolean includeWeakReferences, boolean includeSimpleReferences)` Create a dynamic operand that evaluates to the values of a single reference property of the node identified by the selector.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor visitor)` Accept the supplied visitor, which should call back to the visitor to complete the double-dispatch operation.
    `boolean` | `equals(Object obj)`
    `String` | `getPropertyName()` Get the name of the one reference property.
    `String` | `getSelectorName()` Get the selector symbol upon which this operand applies.
    `int` | `hashCode()`
    `boolean` | `includeSimpleReferences()` Return whether simple references should be included
    `boolean` | `includesWeakReferences()` Get whether weak references should be included.
    `SelectorName` | `selectorName()` Get the selector symbol upon which this operand applies.
    `Set<SelectorName>` | `selectorNames()` Get the selector symbols to which this operand applies.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ReferenceValue

          public ReferenceValue(SelectorName selectorName)

      Create a dynamic operand that evaluates to all of the reference values of the node identified by the selector.
      Parameters:
        `selectorName` - the name of the selector
      Throws:
        `IllegalArgumentException` - if the selector name is null

    - #### ReferenceValue

          public ReferenceValue(SelectorName selectorName,
                        String propertyName,
                        boolean includeWeakReferences,
                        boolean includeSimpleReferences)

      Create a dynamic operand that evaluates to the values of a single reference property of the node identified by the selector.
      Parameters:
        `selectorName` - the name of the selector
        `propertyName` - the name of the property
        `includeWeakReferences` - true if weak references are to be included
        `includeSimpleReferences` - true if simple references are to be included
      Throws:
        `IllegalArgumentException` - if the selector name is null

    - #### ReferenceValue

          public ReferenceValue(SelectorName selectorName,
                        String propertyName)

      Create a dynamic operand that evaluates to the values of a single reference property of the node identified by the selector.
      Parameters:
        `selectorName` - the name of the selector
        `propertyName` - the name of the property
      Throws:
        `IllegalArgumentException` - if the selector name is null

  - ### Method Detail

    - #### selectorName

          public SelectorName selectorName()

      Get the selector symbol upon which this operand applies.
      Returns:
        the one selector names used by this operand; never null

    - #### getSelectorName

          public String getSelectorName()

      Description copied from interface: `ReferenceValue`
      Get the selector symbol upon which this operand applies.
      Specified by:
        `getSelectorName` in interface `ReferenceValue`
      Returns:
        the one selector names used by this operand; never null

    - #### selectorNames

          public Set<SelectorName> selectorNames()

      Description copied from interface: `DynamicOperand`
      Get the selector symbols to which this operand applies.
      Returns:
        the immutable ordered set of non-null selector names used by this operand; never null and never empty

    - #### getPropertyName

          public final String getPropertyName()

      Description copied from interface: `ReferenceValue`
      Get the name of the one reference property.
      Specified by:
        `getPropertyName` in interface `ReferenceValue`
      Returns:
        the property name; or null if this operand applies to any reference property

    - #### includesWeakReferences

          public boolean includesWeakReferences()

      Get whether weak references should be included.
      Returns:
        true if weak references should be included, or false otherwise

    - #### includeSimpleReferences

          public boolean includeSimpleReferences()

      Return whether simple references should be included
      Returns:
        true if simple references should be included, false otherwise.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### equals

          public boolean equals(Object obj)

      Overrides:
        `equals` in class `Object`

    - #### accept

          public void accept(Visitor visitor)

      Description copied from interface: `Visitable`
      Accept the supplied visitor, which should call back to the visitor to complete the double-dispatch operation.
      Specified by:
        `accept` in interface `Visitable`
      Parameters:
        `visitor` - the visitor; never null

Copyright © 2008-2014 JBoss, a division of Red Hat. All Rights Reserved.